KGenericFactory< KTypeList< Product, ProductListTail >, QObject > Class Template Reference

`#include <kgenericfactory.h>`

Inheritance diagram for KGenericFactory< KTypeList< Product, ProductListTail >, QObject >:

## Public Member Functions

| KGenericFactory (const char *instanceName=0)
| KGenericFactory (const KAboutData *data)
Public Member Functions inherited from KLibFactory
| KLibFactory (QObject *parent=0, const char *name=0)
QObject * | create (QObject *parent=0, const char *name=0, const char *classname="QObject", const QStringList &args=QStringList())

## Protected Member Functions

virtual QObject * | createObject (QObject *parent, const char *name, const char *className, const QStringList &args)
Protected Member Functions inherited from KLibFactory
virtual void | virtual_hook (int id, void *data)

## Additional Inherited Members

Signals inherited from KLibFactory
void | objectCreated (QObject *obj)

## Detailed Description

### template<class Product, class ProductListTail>
class KGenericFactory< KTypeList< Product, ProductListTail >, QObject >

This template provides a generic implementation of a KLibFactory , for use with shared library components.

It implements the pure virtual createObject method of KLibFactory and instantiates objects of the specified classes in the given typelist template argument when the class name argument of createObject matches a class names in the given hierarchy of classes.

Note that each class in the specified in the typelist template argument needs to provide a certain constructor:

- If the class is derived from QObject then it needs to have a constructor like: `MyClass( QObject *parent, const char *name, const QStringList &args );`
- If the class is derived from QWidget then it needs to have a constructor like: `MyWidget( QWidget *parent, const char *name, const QStringList &args);`
- If the class is derived from KParts::Part then it needs to have a constructor like: `MyPart( QWidget *parentWidget, const char *widgetName, QObject *parent, const char *name, const QStringList &args );`

The args QStringList passed to the constructor is the args string list that the caller passed to KLibFactory's create method.

In addition upon instantiation this template provides a central KInstance object for your component, accessible through the static instance() method. The instanceName argument of the KGenericFactory constructor is passed to the KInstance object.

The creation of the KInstance object can be customized by inheriting from this template class and re-implementing the virtual createInstance method. For example it could look like this:

KInstance *MyFactory::createInstance()
{
return new KInstance( myAboutData );
}

Example of usage of the whole template:

class MyPlugin : public KParts::Plugin
{
Q_ OBJECT
public:
MyPlugin( QObject *parent, const char *name,
const QStringList &args );
...
};
class MyDialogComponent : public KDialogBase
{
Q_ OBJECT
public:
MyDialogComponent( QWidget *parentWidget, const char *name,
const QStringList &args );
...
};
typedef K_TYPELIST_2( MyPlugin, MyDialogComponent ) Products;
K_EXPORT_COMPONENT_FACTORY( libmyplugin, KGenericFactory&lt;Products&gt; )

Definition at line 266 of file kgenericfactory.h.

## Constructor & Destructor Documentation

template<class Product , class ProductListTail >

KGenericFactory< KTypeList< Product, ProductListTail >, QObject >::KGenericFactory | ( | const KAboutData * | data | ) |

inline

Since
  3.3

Definition at line 278 of file kgenericfactory.h.

## Member Function Documentation

template<class Product , class ProductListTail >

virtual QObject* KGenericFactory< KTypeList< Product, ProductListTail >, QObject >::createObject | ( | QObject * | parent,
|  | const char * | name,
|  | const char * | className,
|  | const QStringList & | args
| ) |  |

inline protected virtual

Creates a new object.

The returned object has to be derived from the requested classname.

It is valid behavior to create different kinds of objects depending on the requested `className`. For example a koffice library may usually return a pointer to KoDocument. But if asked for a "QWidget", it could create a wrapper widget, that encapsulates the Koffice specific features.

This function is called by create()

Parameters

  parent | the parent of the QObject, 0 for no parent
  name | the name of the QObject, 0 for no name
  className | the name of the class
  args | a list of arguments

Implements KLibFactory.

Definition at line 284 of file kgenericfactory.h.

The documentation for this class was generated from the following file:

- kgenericfactory.h

KDE Home | KDE Accessibility Home | Description of Access Keys